include \asm\64\win64.inc

.const
progman BYTE 'Progman',0
shell   BYTE 'SHELLDLL_DefView',0
lview   BYTE 'SysListView32',0
fname    db 'pos.dat',0

.data?
hfile    dq ?
hwnd     dq ?
hprocess dq ?
hmem     dq ?
point    dq ?
pid      dd ?
count    dd ?
written  dd ?
string   db 260 dup (?)

.data
item     LVITEM <LVIF_TEXT,0,0,0,0,0,0,260,0,0,0,0,0,0,0,0>

.code
public start

get_desktop_listview:           ;returns rax=handle else 0 on error
        push rsi                ;one push aligns the stack
        sub rsp,20h             ;api call only uses 4 params
        mov rsi,FindWindowExA
        sub ecx,ecx
        sub edx,edx
        lea r8,progman
        sub r9d,r9d
        call rsi
        test rax,rax
        jz @f
        mov rcx,rax
        sub edx,edx
        lea r8,shell
        sub r9d,r9d
        call rsi
        test rax,rax
        jz @f
        mov rcx,rax
        sub edx,edx
        lea r8,lview
        sub r9d,r9d
        call rsi
    @@: add rsp,20h
        pop rsi
        ret



get_desktop_process:            ;returns rax=handle else 0 on error
        sub rsp,28h
        mov rcx,hwnd
        lea rdx,[rsp+20h]       ;local pid:dword is here
        call GetWindowThreadProcessId
        mov ecx,PROCESS_VM_ALL
        sub edx,edx
        mov r8d,[rsp+20h]
        call OpenProcess
        add rsp,28h
        ret



get_icon_count:                 ;returns rax=handle else 0 on error? or a clean desktop I suppose
        sub rsp,28h
        mov rcx,hwnd
        mov edx,LVM_GETITEMCOUNT
        sub r8d,r8d
        sub r9d,r9d
        call SendMessageA
        add rsp,28h
        ret



open_write_file:                ;rcx=pointer to name, returns rax=handle else -1 (INVALID_HANDLE_VALUE)
        mov eax,CREATE_ALWAYS
        mov edx,GENERIC_WRITE
        sub r8d,r8d
        sub r9d,r9d
        push r8
        push r8
        push rax
        sub rsp,20h
        call CreateFileA
        add rsp,38h
        ret



alloc_process_mem:
        sub rsp,28h
        mov eax,PAGE_READWRITE
        mov rcx,hprocess
        sub edx,edx
        mov r8d,4096
        mov r9d,MEM_COMMIT
        mov [rsp+20h],rax
        call VirtualAllocEx
        add rsp,28h
        ret



write_to_file:  ;rcx=buffer edx=buflen, no return
        push rax            ;align the stack
        push rax            ;local written:dword
        push 0              ;lpOverlapped for WriteFile
        sub rsp,20h
        mov r8d,edx
        lea r9,[rsp+30h]    ;written
        mov rdx,rcx
        mov rcx,hfile
        call WriteFile
        add rsp,38h
        ret



get_item_pos:               ;ecx=index  returns point struc filled
        sub rsp,28h
        mov r8d,ecx
        mov r9,hmem
        mov rcx,hwnd
        mov edx,LVM_GETITEMPOSITION
        call SendMessageA
        mov rcx,hprocess
        mov rdx,hmem
        lea r8,point
        mov r9d,8
        and qword ptr [rsp+20h],0
        call ReadProcessMemory
        add rsp,28h
        ret



get_item_text:        
        push rsi
        sub rsp,30h
        mov esi,ecx
        
        lea r8,item
        mov r9d,sizeof item
        and qword ptr [rsp+20h],0
        mov (LVITEM ptr [r8]).iItem,ecx
        mov rdx,hmem
        mov rcx,hprocess
        call WriteProcessMemory

        mov rcx,hwnd
        mov edx,LVM_GETITEMTEXT
        mov r8d,esi
        mov r9,hmem
        call SendMessageA
        lea esi,[eax+1]
        
        mov rcx,hprocess
        mov rdx,item.pszText
        lea r8,string
        mov r9d,esi
        and qword ptr [rsp+20h],0
        call ReadProcessMemory

        add rsp,30h
        pop rsi
        ret




start:  sub rsp,28h

        call get_desktop_listview
        test rax,rax
        jz get_desktop_listview_failed
        mov hwnd,rax

        call get_desktop_process
        test rax,rax
        jz get_desktop_process_failed
        mov hprocess,rax
        
        call get_icon_count
        test eax,eax
        jz get_icon_count_failed
        mov count,eax

        lea rcx,fname
        call open_write_file
        cmp rax,-1
        jz open_write_file_failed
        mov hfile,rax

        call alloc_process_mem
        test rax,rax
        jz alloc_process_mem_failed
        mov hmem,rax
        lea rax,[rax+sizeof item]
        mov item.pszText,rax

        lea rcx,count
        mov edx,4
        call write_to_file

        sub ebx,ebx

next:   mov ecx,ebx
        call get_item_pos
        mov ecx,ebx
        call get_item_text

        lea rcx,point
        mov edx,8
        call write_to_file

        lea rcx,string
        call lstrlenA
        
        lea rcx,string
        lea edx,[eax+1]
        call write_to_file

        inc ebx
        cmp ebx,count
        jb next

        mov rcx,hfile
        call CloseHandle
        
fini:   mov rcx,hmem
        mov rdx,rdi
        sub r8d,r8d
        mov r9d,MEM_RELEASE
        call VirtualFreeEx




get_desktop_listview_failed:
get_desktop_process_failed:
get_icon_count_failed:
open_write_file_failed:
alloc_process_mem_failed:

failed:
 done:  mov rcx,hprocess
        call CloseHandle

        sub ecx,ecx
        call ExitProcess


main:
        ret
        
end




